#ifndef __RSRCSTRUCTS_H__
#define __RSRCSTRUCTS_H__

#include <stdio.h>

#include <vector>

using namespace std;

struct RsrcDirTableHead {
	DWORD Characteristics;
	DWORD TimeDateStamp;
	WORD  VersionMajor;
	WORD  VersionMinor;
	WORD  NumNameEntries;
	WORD  NumIDEntries;
};

struct RsrcDirEntry {
	union {
		DWORD NameRVA;
		DWORD IntegerID;
	};
	union {
		DWORD DataEntryRVA;
		DWORD SubdirectoryRVA;
	};
};

struct RsrcDataEntry {
	DWORD DataRVA;
	DWORD Size;
	DWORD Codepage;
	DWORD Reserved;
};

struct TableHead {
	int Level;	//0 = Type, 1 = Name, 2 = Language

	union {
		DWORD  TypeID;
		LPWSTR TypeString;
	};

	union {
		DWORD  NameID;
		LPWSTR NameString;
	};

	DWORD Characteristics;
	DWORD TimeDateStamp;
	WORD  VersionMajor;
	WORD  VersionMinor;

	bool operator<(const TableHead &) const {return false;}
	bool operator==(const TableHead &) const {return false;}
};

struct Resource {
	union {
		DWORD  NameID;
		LPWSTR NameString;
	};

	union {
		DWORD  TypeID;
		LPWSTR TypeString;
	};

	WORD LanguageID;

	DWORD Codepage;

	LPBYTE Data;
	DWORD  DataSize;

	DWORD  Reserved;

	Resource() {memset(this, 0, sizeof(*this));}
	Resource(const Resource *rc) {memcpy(this, &rc, sizeof(*this));}

	bool operator<(const Resource &) const;
	bool operator==(const Resource &) const;
};

struct RsrcInfo {
	FILE *File;
	int   FilePtrToPEHdr;

	IMAGE_SECTION_HEADER SectionHeader;
	IMAGE_FILE_HEADER    PEHeader;
	vector<Resource>     vtrResources;
	vector<TableHead>    vtrTableHeads;
	vector<LPWSTR>       vtrStrings;

	RsrcInfo() {File = NULL; FilePtrToPEHdr = 0; memset(&SectionHeader, 0, sizeof(IMAGE_SECTION_HEADER)); memset(&PEHeader, 0, sizeof(IMAGE_FILE_HEADER));}
};

#endif //__RSRCSTRUCTS_H__